]> pd.if.org Git - zpackage/blobdiff - zpm-install
add tests for more package installs
[zpackage] / zpm-install
index 487740ddc4dbca063b3cbab96d1177dfa7a60bab..cf0df5f2e89f49ca567188cb27df629ef9728ada 100755 (executable)
 #!/bin/sh
 
-#package=${1:-$ZPMPACKAGE}
-pkgver=${ZPMPACKAGEVER:-1.0}
-pkgrel=${ZPMPACKAGEREL:-1}
-
-pkgroot=/
-
-# allocate an install id, perhaps hash package and timestamp
-# extract pre-scripts and run them
-# get list of paths to install
-# for each path, if directory, create and set mode
-# for each path, create leading directories
-# extract to something like /var/tmp/.hash, with low perms
-# only atomic if same filesystem, so use .installid.hash in the
-# install directory
-# set perms and such
-# move into place
-# after all the files, extract post scripts and run them
-
-# option for "multipackage" just to let the system know that's what you meant
-# option to take filenames from stdin
-# parse package, version, release from file if not given
-while getopts :f:v:r:d:a:u:l:p:b:P:R: opt; do
+die() {
+       echo $* 1>&2
+       exit 1
+}
+
+dryrun=0
+verbose=0
+runscripts=1
+runconfigure=1
+localdb=/var/lib/zpm/local.db
+
+# zpm-install [-SCn] [ -d localdb ] [ -f pkgfile ] [ -R installroot ] pkgstr ...
+while getopts f:d:R:nSCv opt; do
        case $opt in
-               R) pkgroot="$OPTARG" ;;
                f) pkgfile="$OPTARG" ;;
-               v) pkgver="$OPTARG" ;;
-               r) pkgrel="$OPTARG" ;;
-               d) description="$OPTARG" ;;
-               a) arch="$OPTARG" ;;
-               u) url="$OPTARG" ;;
-               l) licenses="$OPTARG" ;;
-               p) packager="$OPTARG" ;;
-               b) builddate="$OPTARG" ;;
-               P) prefix="$OPTARG" ;;
+               d) localdb="$OPTARG" ;;
+               R) rootdir="$OPTARG" ;;
+               S) runscripts=0 ;;
+               C) runconfigure=0 ;;
+               n) dryrun=1 ;;
+               v) verbose=1 ;;
+               *) die "usage ..." ;;
        esac
 done
-shift $((OPTIND - 1))
+shift $(( OPTIND - 1))
+
+pkgid=$1
+
+if [ -z "$pkgid" ]; then
+       die "must specify pkgid"
+fi
+
+eval "$(zpm parse -E $pkgid)"
 
-set -e
 if [ -z "$pkgfile" ]; then
-       # actually, if no pkgfile, get pkgfile from repo
-       pkgfile="$package-$pkgver-$pkgrel.zpm"
+       pkgfile=$ZPM_PACKAGE_FILE
 fi
 
-die() {
-       echo $* 1&>2
-       exit 1
-}
+# cases C = create ok, R = full package id, F = specified package file
+
+# immediate error
+# C-- 100 error, must specify something
+# --- 000 error, must specify something
+if [ -z "$release" ] && [ -z "$pkgfile" ]; then
+       die must specify package file or complete package id
+fi
+
+# TODO look in package file
+# --F 001 error, wouldn't know which pkgid to create, could derive from file?
+# C-F 101 error, since package wouldn't exist in file to find
+if [ -z "$release" ]; then
+       die must specify complete package id
+fi
+
+# set file from pkgid
+# CR- 110 set file from pkgid, create if needed
+# -R- 010 set file from pkgid, create in file, error if no file
+if [ -z "$pkgfile" ]; then
+       pkgfile="$pkgid.zpm"
+fi
+
+# will now be one of these
+# CRF 111 create package in file given, create file if needed
+# -RF 011 create package in file, error if file doesn't exist
+if [ ! -f "$pkgfile" ]; then
+       if [ $create -eq 1 ]; then
+               zpm init $pkgfile
+       else
+               die $pkgfile does not exist
+       fi
+fi
+
+if [ "$idempotent" = 1 ]; then
+       idempotent='or ignore'
+fi
 
-set -e
-zpm test -v $pkgfile
-set +e
+package=$(zpm quote "$name")
+pkgver=$(zpm quote "$version")
+pkgrel=$(zpm quote "$release")
 
-if [ $# -gt 0 ]; then
-       pkglist="$@"
+ZPMDB=$localdb
+export ZPMDB
+
+if [ -z "$ZPMDB" ]; then
+       die "no local db"
 else
-       pkglist=$(zpm findpkg $pkgfile)
+       #echo "localdb = $ZPMDB"
+       true
 fi
 
-pathlist() {
-       sqlite3 $pkgfile<<EOS
-select path from packagefiles
-       where package||'-'||version||'-'||release = '$pkg'
-       ;
-EOS
-}
+zpm test -v "$ZPMDB" || die "$ZPMDB is not a zpm database"
+
+# check if we're installing something already
+var=$(zpm list -f $localdb -s installing | wc -l)
+if [ $var -gt 0 ]; then
+       zpm list -v -f $localdb -s installing 
+       die "already ($localdb) installing $var package(s)"
+fi
 
-for pkg in $pkglist; do
-       # TODO find scripts marked as pre-install
-       # TODO if this is an upgrade, run pre-upgrade
+if [ -n "$rootdir" ]; then
+       ZPM_ROOT_DIR="$rootdir"
+       export ZPM_ROOT_DIR
+fi
 
-       # TODO get total size of install so we can do a progress bar
+# TODO mark already installed packages as updating?
+for pkgstr in "$@"; do
+       pkgid=$(zpm findpkg $pkgfile $pkgstr)
+       if [ $? -ne 0 ]; then
+               # TODO log
+               die "can't find package $pkgstr in $pkgfile"
+       fi
 
-       # add package info to local package db
-       # zpm merge -L -f $pkgfile $pkg
-       # mark package in localdb as installing
-       # zpm setmark installing $pkg
-       # install all the files for a package
-       # TODO install directories first in order of path length
-       pathlist | xargs zpm ipkgfile -R "$pkgroot" -f $pkgfile -- $pkg 
+       curstatus=$(zpm pkg $pkgid status)
+       if [ "$curstatus" = 'installed' ]; then
+               die "$pkgid already installed"
+       fi
 
-       # TODO find scripts marked as post-install
-       # TODO if this is an upgrade, run post-upgrade
+       eval $(zpm parse -E $pkgid)
 
-       # mark as ready for install
-       #zpm setmark ready $pkg
-done
+       #zpm list -v
+       current=$(zpm list -s installed "$package")
+       
+       if [ $runscripts -gt 0 ]; then
+               zpm runscript -f $pkgfile -p pre-install $pkgid $current
+               if [ $? -ne 0 ]; then
+                       # TODO log
+                       die "pre-install script for $pkgid failed"
+               fi
+       fi
+
+       # only merge if localdb and pkgfile are different
+       if [ "$pkgfile" != "$ZPMDB" ]; then
+               zpm merge -f $pkgfile -s installing $pkgid
+               if [ $? -ne 0 ]; then
+                       # TODO log
+                       die "merging $pkgid failed"
+               fi
+       fi
+
+       #zpm shell $ZPMDB 'select * from install_status' 1>&2
+       if [ $dryrun -gt 0 ]; then
+               #zpm list -v
+               #zpm shell $ZPMDB 'select * from install_status'
+               zpm pkgfiles -nv -f $pkgfile $pkgid
+               zpm pkg $pkgid status=dryrun
+               continue
+       fi
+
+       zpm pkgfiles -f $pkgfile $pkgid
 
-#zpm setmark installed $pkglist
+       if [ $? -ne 0 ]; then
+               die 'zpm-pkgfiles failed';
+       fi
+
+       if [ $runscripts -gt 0 ]; then
+               zpm runscript -f $pkgfile -p post-install $pkgid $current
+       fi
+
+       if [ -n "$current" ]; then
+               zpm pkg $pkgid status=installed :$current status=updated
+       else
+               zpm pkg $pkgid status=installed
+       fi
+
+       # TODO skip configure if not on a terminal, regardless of settings
+       # TODO will need force option
+       if [ $runconfigure -gt 0 ]; then
+               zpm runscript -f $pkgfile -p configure $pkgid $current
+       fi
+done